/**
 * @file      Node entry and main driver
 * @author    Jordan Lavatai, Ken Grimes
 * @version   0.0.1
 * @license   AGPL-3.0
 * @copyright jk software 2017
 * @summary   HTTP(S) Router that uses the first directory in the requested URL
 *            as the route name
 */
const fs = require('fs')
const ws = require('ws')
const http = require('http')
const https = require('https')
const getport = require('get-port')
const mime = require('mime')
const opts = require('./opts.js')

/* const routeConnection = (request,response) => {
  const htArgv = request.url.slice(1).split("?")
  let   routeName = /[^\/]*/.match(htArgv[0])[0]
  if (routeName === '')
    routeName = opts['index']
  if (routeName.indexOf('.') != -1) {
    if (routeName in fileBuf) {
      response.writeHead(200, { 'Content-Type': fileBuf[routeName].mime })
      response.write(fileBuf[routeName].data)
    }
    else {
      if ('404.html' in fileBuf) {
	response.writeHead(404, fileBuf['404.html'].mime)
	response.write(fileBuf['404.html'].data)
      }
      else
	response.writeHead(404)
    }
    response.end()
  }
  else if (routeName in routes) {
    const route = routes[routeName]
    response.writeHead(200, { 'Content-Type': 'text/html' })
    response.write(skelPage[0] + clientJS + skelPage[1])
    response.end()
    route.socket.send(request.headers['x-forwarded-for'] || request.connection.remoteAddress)
  }
  else {
    routes[htArgv[0]] = true
    const newRoute = {}
    newRoute.host = request.headers['x-forwarded-for'] || request.connection.remoteAddress
    getport().then( (port) => {
      newRoute.port = port
      newRoute.httpd = https.createServer(routerOpts, (request, response) => {
      }).listen(newRoute.port)
      
      newRoute.ws = new ws.Server( { server: newRoute.httpd } )
      newRoute.ws.on('connection', (ws) => { console.log("socket connected"); newRoute.socket = ws; ws.send("CONNECTED") } )
      newRoute.ws.on('message', (msg) => { console.log("Received message" + msg) })
      console.log("Listening for websocket " + newRoute.host + " on port " + newRoute.port)
      routes[htArgv[0]] = newRoute
    }).then(() => {
      response.writeHead(200, { 'Content-Type': 'text/html' })
      response.write(skelPage[0] + 'const _strapp_port = \'' + newRoute.port + '\'\n' + hostJS + skelPage[1])
      response.end()
    })
  }
}

if (!opts['no-tls']) {
  router.httpd = http.createServer(router.listener)
}
else {
  /* Setup TLS */
  if (!fs.existsSync(opts['ca-key'])) {
    console.log(`ERR: Key ${opts['ca-key']} inaccessible (required for tls)`)
    process.exit()
  }
  if (!fs.existsSync(opts['ca-cert'])) {
    console.log(`ERR: Cert ${opts['ca-cert']} inaccessible (required for tls)`)
    process.exit()
  }
  router.opts = {
    key: fs.readFileSync(opts['ca-key']),
    cert: fs.readFileSync(opts['ca-cert'])
  }
}

const skelPage = String(fs.readFileSync('skel.html')).split("<!--STRAPP_SRC-->")
const clientJS = fs.readFileSync(opts['client-js'])
const hostJS   = fs.readFileSync(opts['host-js'])
const routes   = {}
/*
const router = https.createServer(routerOpts, (request, response) => {
  const htArgv = request.url.slice(1).split("?")
  let   routeName = htArgv[0].split('/')[0]
  if (routeName === '')
    routeName = 'index.html'
  if (routeName.indexOf('.') != -1) {
    if (routeName in fileBuf) {
      response.writeHead(200, { 'Content-Type': fileBuf[routeName].mime })
      response.write(fileBuf[routeName].data)
    }
    else {
      if ('404.html' in fileBuf) {
	response.writeHead(404, fileBuf['404.html'].mime)
	response.write(fileBuf['404.html'].data)
      }
      else
	response.writeHead(404)
    }
    response.end()
  }
  else if (routeName in routes) {
    const route = routes[routeName]
    response.writeHead(200, { 'Content-Type': 'text/html' })
    response.write(skelPage[0] + clientJS + skelPage[1])
    response.end()
    route.socket.send(request.headers['x-forwarded-for'] || request.connection.remoteAddress)
  }
  else {
    routes[htArgv[0]] = true
    const newRoute = {}
    newRoute.host = request.headers['x-forwarded-for'] || request.connection.remoteAddress
    getport().then( (port) => {
      newRoute.port = port
      newRoute.httpd = https.createServer(routerOpts, (request, response) => {
      }).listen(newRoute.port)
      
      newRoute.ws = new ws.Server( { server: newRoute.httpd } )
      newRoute.ws.on('connection', (ws) => { console.log("socket connected"); newRoute.socket = ws; ws.send("CONNECTED") } )
      newRoute.ws.on('message', (msg) => { console.log("Received message" + msg) })
      console.log("Listening for websocket " + newRoute.host + " on port " + newRoute.port)
      routes[htArgv[0]] = newRoute
    }).then(() => {
      response.writeHead(200, { 'Content-Type': 'text/html' })
      response.write(skelPage[0] + 'const _strapp_port = \'' + newRoute.port + '\'\n' + hostJS + skelPage[1])
      response.end()
    })
  }
}).listen(argv['port'])
*/
//TODO: if ("electron" in process.versions) open a local renderwindow, and route to it

